package cn.iocoder.yudao.module.member.enums;

import com.google.common.collect.Sets;

import java.util.Set;

public enum ScoreSourceTypeEnum {
    MANUAL_OPERATE(1, "人工操作", null),

    EXCHANGE_REWARD(2, "兑换礼品", ScoreOperateTypeEnum.REDUCE),

    SYSTEM_EXPIRED(3, "系统失效", ScoreOperateTypeEnum.REDUCE),
    ;

    private final int value;

    private final String name;

    private final ScoreOperateTypeEnum operateType;

    ScoreSourceTypeEnum(int value, String name, ScoreOperateTypeEnum operateType) {
        this.value = value;
        this.name = name;
        this.operateType = operateType;
    }

    public int getValue() {
        return value;
    }

    public String getName() {
        return name;
    }

    public ScoreOperateTypeEnum getOperateType() {
        return operateType;
    }

    public static Set<ScoreSourceTypeEnum> getInvalidScoreStatusSourceType() {
        return Sets.newHashSet(MANUAL_OPERATE, SYSTEM_EXPIRED);
    }
}
