package cn.iocoder.yudao.module.member.dal.mysql.scoreRule;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.member.dal.dataobject.scoreRule.ScoreRuleDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.member.vo.scoreRule.ScoreRuleQueryVO;
import org.apache.ibatis.annotations.Mapper;

/**
 * 积分规则 DO Mapper
 * @author 系统管理员
 */
@Mapper
public interface ScoreRuleMapper extends AbstractMapper<ScoreRuleDO> {
    @Override
    default PageResult<ScoreRuleDO> selectPage(PageVO page, Object object) {
        if (object instanceof ScoreRuleQueryVO) {
            ScoreRuleQueryVO vo = (ScoreRuleQueryVO)object;
            return selectPage(page, new LambdaQuery<ScoreRuleDO>()
                .eqIfPresent(ScoreRuleDO::getType, vo.getType())
                .eqIfPresent(ScoreRuleDO::getTitleZh, vo.getTitleZh())
                .eqIfPresent(ScoreRuleDO::getTitleEn, vo.getTitleEn())
                .eqIfPresent(ScoreRuleDO::getDescZh, vo.getDescZh())
                .eqIfPresent(ScoreRuleDO::getDescEn, vo.getDescEn())
                .eqIfPresent(ScoreRuleDO::getCoverImageZh, vo.getCoverImageZh())
                .eqIfPresent(ScoreRuleDO::getCoverImageEn, vo.getCoverImageEn())
                .eqIfPresent(ScoreRuleDO::getGetScoreOnce, vo.getGetScoreOnce())
                .eqIfPresent(ScoreRuleDO::getMaxScoreTotal, vo.getMaxScoreTotal())
                .betweenIfPresent(ScoreRuleDO::getStartTime, vo.getBeginStartTime(), vo.getEndStartTime())
                .betweenIfPresent(ScoreRuleDO::getEndTime, vo.getBeginEndTime(), vo.getEndEndTime())
                .eqIfPresent(ScoreRuleDO::getSocrePeriod, vo.getSocrePeriod())
                .eqIfPresent(ScoreRuleDO::getOrderNum, vo.getOrderNum())
                .eqIfPresent(ScoreRuleDO::getPushActivity, vo.getPushActivity())
                .eqIfPresent(ScoreRuleDO::getShowPlatform, vo.getShowPlatform())
                .eqIfPresent(ScoreRuleDO::getStatus, vo.getStatus())
                .eqIfPresent(ScoreRuleDO::getExtra, vo.getExtra())
                .betweenIfPresent(ScoreRuleDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(ScoreRuleDO::getId));
        }

        return null;
    }

    @Override
    default List<ScoreRuleDO> selectList(Object object) {
        if (object instanceof ScoreRuleQueryVO) {
            ScoreRuleQueryVO vo = (ScoreRuleQueryVO)object;
            return selectList(new LambdaQuery<ScoreRuleDO>()
                .eqIfPresent(ScoreRuleDO::getType, vo.getType())
                .eqIfPresent(ScoreRuleDO::getTitleZh, vo.getTitleZh())
                .eqIfPresent(ScoreRuleDO::getTitleEn, vo.getTitleEn())
                .eqIfPresent(ScoreRuleDO::getDescZh, vo.getDescZh())
                .eqIfPresent(ScoreRuleDO::getDescEn, vo.getDescEn())
                .eqIfPresent(ScoreRuleDO::getCoverImageZh, vo.getCoverImageZh())
                .eqIfPresent(ScoreRuleDO::getCoverImageEn, vo.getCoverImageEn())
                .eqIfPresent(ScoreRuleDO::getGetScoreOnce, vo.getGetScoreOnce())
                .eqIfPresent(ScoreRuleDO::getMaxScoreTotal, vo.getMaxScoreTotal())
                .betweenIfPresent(ScoreRuleDO::getStartTime, vo.getBeginStartTime(), vo.getEndStartTime())
                .betweenIfPresent(ScoreRuleDO::getEndTime, vo.getBeginEndTime(), vo.getEndEndTime())
                .eqIfPresent(ScoreRuleDO::getSocrePeriod, vo.getSocrePeriod())
                .eqIfPresent(ScoreRuleDO::getOrderNum, vo.getOrderNum())
                .eqIfPresent(ScoreRuleDO::getPushActivity, vo.getPushActivity())
                .eqIfPresent(ScoreRuleDO::getShowPlatform, vo.getShowPlatform())
                .eqIfPresent(ScoreRuleDO::getStatus, vo.getStatus())
                .eqIfPresent(ScoreRuleDO::getExtra, vo.getExtra())
                .betweenIfPresent(ScoreRuleDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(ScoreRuleDO::getId));
        }

        return null;
    }
}
