package cn.iocoder.yudao.module.member.vo.scoreRule;

import cn.iocoder.yudao.module.member.vo.scoreRule.extra.ScoreRuleOrderVExtraVO;
import cn.iocoder.yudao.module.member.vo.scoreRule.extra.ScoreRuleRegisterExtraVO;
import cn.iocoder.yudao.module.member.vo.scoreRule.extra.ScoreRuleShareExtraVO;
import cn.iocoder.yudao.module.member.vo.scoreRule.extra.ScoreRulerRecommendExtraVO;
import com.baomidou.dynamic.datasource.annotation.DS;
import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import org.springframework.format.annotation.DateTimeFormat;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 积分规则 Response VO
* @author 系统管理员
*/
@Data
@ApiModel("管理后台 - 积分规则 Response VO")
public class ScoreRuleBackVO {

    @ExcelProperty("主键")
    @ApiModelProperty(value = "主键", required = true)
    private Long id;

    @ExcelProperty("指标类型")
    @ApiModelProperty(value = "指标类型", required = true)
    private Integer type;

    @ExcelProperty("规则标题中文")
    @ApiModelProperty(value = "规则标题中文", required = true)
    private String titleZh;

    @ExcelProperty("规则标题英文")
    @ApiModelProperty(value = "规则标题英文", required = true)
    private String titleEn;

    @ExcelProperty("规则说明中文")
    @ApiModelProperty(value = "规则说明中文", required = true)
    private String descZh;

    @ExcelProperty("规则说明英文")
    @ApiModelProperty(value = "规则说明英文", required = true)
    private String descEn;

    @ExcelProperty("封面图中文")
    @ApiModelProperty(value = "封面图中文")
    private String coverImageZh;

    @ExcelProperty("封面图英文")
    @ApiModelProperty(value = "封面图英文")
    private String coverImageEn;

    @ExcelProperty("单次获取积分数")
    @ApiModelProperty(value = "单次获取积分数", required = true)
    private Integer getScoreOnce;

    @ExcelProperty("累积最高积分")
    @ApiModelProperty(value = "累积最高积分", required = true)
    private Integer maxScoreTotal;

    @ExcelProperty("活动开始时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "活动开始时间", required = true)
    private Date startTime;

    @ExcelProperty("活动结束时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "活动结束时间", required = true)
    private Date endTime;

    @ExcelProperty("积分有效期")
    @ApiModelProperty(value = "积分有效期", required = true)
    private Integer socrePeriod;

    @ExcelProperty("排序值")
    @ApiModelProperty(value = "排序值", required = true)
    private Integer orderNum;

    @ExcelProperty("是否推送")
    @ApiModelProperty(value = "是否推送", required = true)
    private Integer pushActivity;

    @ExcelProperty("展示平台")
    @ApiModelProperty(value = "展示平台", required = true)
    private String showPlatform;

    @ExcelProperty("活动状态")
    @ApiModelProperty(value = "活动状态", required = true)
    private Integer status;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

    @ApiModelProperty(value = "扩展字段原始")
    private String extra;
    @ApiModelProperty(value = "订单V值扩展字段")
    private ScoreRuleOrderVExtraVO extraOrderV;
    @ApiModelProperty(value = "注册扩展字段")
    private ScoreRuleRegisterExtraVO extraRegister;
    @ApiModelProperty(value = "推荐扩展字段")
    private ScoreRulerRecommendExtraVO extraRecommend;
    @ApiModelProperty(value = "分享扩展字段")
    private ScoreRuleShareExtraVO extraShare;

}
