package cn.iocoder.yudao.module.member.vo.scoreRule;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@Data
@ApiModel("管理后台 - 积分规则查询 VO")
public class ScoreRuleQueryVO {

    @ApiModelProperty(value = "指标类型")
    private Integer type;

    @ApiModelProperty(value = "规则标题中文")
    private String titleZh;

    @ApiModelProperty(value = "规则标题英文")
    private String titleEn;

    @ApiModelProperty(value = "规则说明中文")
    private String descZh;

    @ApiModelProperty(value = "规则说明英文")
    private String descEn;

    @ApiModelProperty(value = "封面图中文")
    private String coverImageZh;

    @ApiModelProperty(value = "封面图英文")
    private String coverImageEn;

    @ApiModelProperty(value = "单次获取积分数")
    private Integer getScoreOnce;

    @ApiModelProperty(value = "累积最高积分")
    private Integer maxScoreTotal;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始活动开始时间")
    private Date beginStartTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束活动开始时间")
    private Date endStartTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始活动结束时间")
    private Date beginEndTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束活动结束时间")
    private Date endEndTime;

    @ApiModelProperty(value = "积分有效期")
    private Integer socrePeriod;

    @ApiModelProperty(value = "排序值")
    private Integer orderNum;

    @ApiModelProperty(value = "是否推送")
    private Integer pushActivity;

    @ApiModelProperty(value = "展示平台")
    private String showPlatform;

    @ApiModelProperty(value = "活动状态")
    private Integer status;

    @ApiModelProperty(value = "扩展字段")
    private String extra;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private Date beginCreateTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private Date endCreateTime;

}
